{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvAnimTitle.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvAnimTitle;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ExtCtrls, Forms;

type
  TJvAnimtitle = class(TComponent)
  private
    FTimer: TTimer;
    Fenable: boolean;
    titre_initial,titre: string;
    vitesse: Integer;
    sens: boolean;
    FForm: TCustomForm;
    blinker: Integer;
    blinked: Integer;
    blinking: boolean;
    procedure change_title(titre2:string);
    procedure enable_change(enable2:boolean);
    procedure change_delay(newdelay : integer);
    procedure lethread(Sender: TObject);
  protected
  public
    constructor Create (AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Title : string read titre_initial write change_title;
    property Enabled : boolean read FEnable write enable_change default false;
    property Delay : Integer read vitesse write change_delay default 50;
    property Blink : Integer read blinker write blinker default 5;
  end;

implementation

{**************************************************}
procedure TJvAnimtitle.lethread(Sender: TObject);
begin
   if blinking then
   begin
      if FForm.Caption=titre_initial then
        FForm.caption:=''
      else
      begin
        FForm.Caption:=titre_initial;
        inc(blinked);
        if blinked>=blinker then
        begin
          blinking:=false;
          blinked:=0;
        end;
      end;
   end
   else
   begin
      if sens then
      begin
         if length(titre)=length(titre_initial) then
         begin
            sens:=false;
            if blinker>0 then blinking:=true;
         end
         else
            titre:=titre+titre_initial[length(titre)+1];
      end
      else
         if length(titre)=0 then sens:=true else
              titre:=Copy(titre,0,length(titre)-1);
      FForm.caption:=titre;
   end;
end;
{**************************************************}
constructor TJvAnimtitle.Create(AOwner: TComponent);
begin
  inherited;
  FEnable := false;
  vitesse := 50;
  blinker := 5;
  FForm := GetParentForm(TControl(AOwner));
  titre_initial := FForm.Caption;
  sens := true;
  blinking := false;
  blinked := 0;
  vitesse := 100;

  FTimer:=TTimer.Create(self);
  FTimer.Enabled:=FEnable;
  FTimer.Interval:=vitesse;
  FTimer.Ontimer:=lethread;
end;
{**************************************************}
destructor TJvAnimtitle.Destroy;
begin
  FTimer.Free;
  if not(csDestroying in FForm.ComponentState) then
    FForm.Caption:=titre_initial;
  inherited;
end;
{**************************************************}
procedure TJvAnimtitle.change_title(titre2:string);
begin
  titre_initial := titre2;
  titre := '';
  sens := true;
end;
{**************************************************}
procedure TJvAnimtitle.enable_change (enable2:boolean);
begin
  Fenable := enable2;
  FTimer.enabled := Fenable;
end;
{**************************************************}
procedure TJvAnimtitle.change_delay (newdelay:integer);
begin
  vitesse := newdelay;
  Ftimer.interval := vitesse;
end;
{**************************************************}
end.
