{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvBlinkingLabel.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvBlinkingLabel;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, JvLabel,
  ExtCtrls;

type
  TJvBlinkingLabel = class(TJvLabel)
  private
    Fblinking:boolean;
    FTimer:TTimer;
    FDelay:cardinal;
    FBlink:Integer;
    procedure SetBlinking(Value:boolean);
    procedure SetDelay(Value:cardinal);
    procedure OnBLink(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Blinking:boolean read Fblinking write SetBlinking default true;
    property BlinkingDelay:cardinal read FDelay write SetDelay default 400;
    property BlinkingTime:Integer read FBlink write FBlink default 200;
  end;

implementation

{**************************************************}
constructor TJvBlinkingLabel.Create(AOwner: TComponent);
begin
   self.Fblinking:=true;
   self.FDelay:=400;
   self.FBlink:=200;
   inherited;
   FTimer:=TTimer.Create(self);
   FTimer.OnTimer:=OnBlink;
   FTimer.Interval:=FDelay;
   FTimer.enabled:=FBlinking;
end;
{**************************************************}
destructor TJvBlinkingLabel.Destroy;
begin
   FTimer.enabled:=false;
   FTimer.free;
   inherited;
end;
{**************************************************}
procedure TJvBlinkingLabel.SetBlinking(Value:boolean);
begin
   FBlinking:=Value;
   FTimer.enabled:=Value;
   if not(Value) then
       self.visible:=true;
end;
{**************************************************}
procedure TJvBlinkingLabel.SetDelay(Value:cardinal);
begin
   FDelay:=Value;
   FTimer.Interval:=Value;
end;
{**************************************************}
procedure TJvBlinkingLabel.OnBLink(Sender: TObject);
begin
   visible:=not(visible);
   if not(visible) then Ftimer.Interval:=FDelay  else  FTimer.interval:=FBlink;
end;
{**************************************************}
end.
