{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvBouncingLabel.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvBouncingLabel;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, JvLabel, ExtCtrls;

type
  TJvBouncingLabel = class(TJvLabel)
  private
    FBouncing:boolean;
    FTimer:TTimer;
    FDirection:Integer;
    FSpeed:Integer;
    Form:TWinControl;
    FInterval: cardinal;
    procedure Bounce(Sender: TObject);
    procedure SetBouncing(const Value: boolean);
    procedure SetInterval(const Value: cardinal);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Bouncing:boolean read FBouncing write SetBouncing default true;
    property Interval:cardinal read FInterval write SetInterval default 20;
  end;

implementation

resourcestring
   RC_MustBeWinControl          =       'Owner must be of type TWinControl';

{**************************************************}
procedure TJvBouncingLabel.Bounce(Sender: TObject);
begin
   if Fspeed=0 then Fspeed:=random(8);
   case FDirection of
        0: begin
              //numpad1
              if (self.left-FSpeed<=0)or(self.Top+self.Height+FSpeed>=Form.ClientHeight) then
              begin
                 FDirection:=random(4);
                 FSpeed:=random(8);
              end
              else
              begin
                 self.left:=self.left-FSpeed;
                 self.top:=self.top+FSpeed;
              end;
           end;
        1: begin
              if (self.top+self.height+FSpeed>=Form.Clientheight)or(self.left+self.width+FSpeed>=form.Clientwidth) then
              begin
                 FDirection:=random(4);
                 FSpeed:=random(8);
              end
              else
              begin
                 self.top:=self.top+FSpeed;
                 self.left:=self.left+Fspeed;
              end;
           end;
        2: begin
              if (self.left-FSpeed<=0)or(self.top-Fspeed<=0) then
              begin
                 FDirection:=random(4);
                 FSpeed:=random(8);
              end
              else
              begin
                 self.left:=self.left-Fspeed;
                 self.top:=self.top-FSpeed;
              end;
           end;
        3: begin
              if (self.left+self.width+FSpeed>form.Clientwidth)or(self.top-FSpeed<=0) then
              begin
                 FDirection:=random(4);
                 FSpeed:=random(8);
              end
              else
              begin
                 self.left:=self.left+Fspeed;
                 self.top:=self.top-FSpeed;
              end;
           end;
   end;
end;
{**************************************************}
constructor TJvBouncingLabel.Create(AOwner: TComponent);
begin
   inherited;
   randomize;
   Ftimer:=TTimer.Create(nil);
   Ftimer.Interval:=20;
   Finterval:=20;
   FTimer.OnTimer:=Bounce;
   FBouncing:=true;
   FDirection:=random(4);
   FSpeed:=random(8);
   FTimer.enabled:=true;
   if AOwner is TWinControl then
      Form:=AOwner as TWinControl
   else
      raise Exception.Create(RC_MustBeWinControl);
end;
{**************************************************}
destructor TJvBouncingLabel.Destroy;
begin
   FTimer.free;
   inherited;
end;
{**************************************************}
procedure TJvBouncingLabel.SetBouncing(const Value: boolean);
begin
   FBouncing := Value;
   FTimer.Enabled:=Value;
end;
{**************************************************}
procedure TJvBouncingLabel.SetInterval(const Value: cardinal);
begin
   FInterval := Value;
   Ftimer.interval:=Value;
end;
{**************************************************}

end.
