{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvCommonDialogD.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvCommonDialogD;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvTypes, JvHSetup;

type
  TJvCommonDialogD = class(TComponent)
  private
  protected
    FHandle:THandle;
    FDll:THandle;
    FTitle: string;
    FSetupPromptForDisk:TSetupPromptForDisk;
    FSetupRenameError:TSetupRenameError;
    FSetupDeleteError:TSetupDeleteError;
    FSetupCopyError:TSetupCopyError;
  public
    function Execute:TDiskRes;virtual;abstract;
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property DialogTitle:string read FTitle write FTitle;
  end;

implementation

resourcestring
   RC_ErrorSetupDll        =     'Unable to find setupapi.dll';
   RC_ErrorOwner           =     'Owner must be of type TWinControl';

{**************************************************}
constructor TJvCommonDialogD.Create(AOwner: TComponent);
begin
   inherited;
   if Aowner is TWinControl then
   begin
      FTitle:='';
      FHandle:=(Aowner as TWinControl).handle;
      FDll:=LoadLibrary('setupapi.dll');
      if Fdll<>0 then
      begin
         FSetupPromptForDisk:=GetProcAddress(Fdll,'SetupPromptForDiskA');
         FSetupCopyError:=GetProcAddress(Fdll,'SetupCopyErrorA');
         FSetupDeleteError:=GetProcAddress(Fdll,'SetupDeleteErrorA');
         FSetupRenameError:=GetProcAddress(Fdll,'SetupRenameErrorA');
      end
      else
        raise Exception.Create(RC_ErrorSetupDll);
   end
   else raise Exception.Create(RC_ErrorOwner);
end;
{**************************************************}
destructor TJvCommonDialogD.Destroy;
begin
   if Fdll<>0 then
      FreeLibrary(Fdll);
   inherited;
end;
{**************************************************}
end.
