{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvDeleteError.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvDeleteError;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvHSetup, JvCommonDialogD, JvBaseDlg, JvTypes;

type
  TJvDeleteError = class(TJvCommonDialogD)
  private
    FError: Integer;
    FFile: string;
    Fstyle: TDeletestyles;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property FileName:string read FFile write FFile;
    property W32ErrorCode:Integer read FError write FError default 0;
    property style:TDeletestyles read Fstyle write Fstyle;
    function Execute:TDiskRes;override;
  end;

implementation

{**************************************************}
constructor TJvDeleteError.Create(AOwner: TComponent);
begin
   inherited;
   if Aowner is TWinControl then
   begin
      Fstyle:=[];
      FFile:='';
      FError:=0;
   end;
end;
{**************************************************}
function TJvDeleteError.Execute: TDiskRes;
var
   Sty:DWord;
begin
   result:=dsError;
   Sty:=0;
   if (idNoBeep in Fstyle) then Sty:=Sty or idf_NoBeep;
   if (idNoForeground in Fstyle) then Sty:=Sty or idf_NoForeground;

   if @FSetupDeleteError<>nil then
   begin
      case FSetupDeleteError(Fhandle,Pchar(Ftitle),PChar(FFIle),Ferror,sty) of
         DPROMPT_SUCCESS: result:=dsSuccess;
         DPROMPT_CANCEL: result:=dsCancel;
         DPROMPT_SKIPFILE : result:=dsSkipfile;
         else result:=dsError;
      end;
   end;
end;
{**************************************************}
end.
