{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormPlace.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormPlace;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  ExtCtrls, Registry;

type
  TJvFormPlace = class(TComponent)
  private
    FBoolean: boolean;
    FForm: TCustomForm;
    FTImer:TTimer;
    procedure Rememb(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Remember:boolean read FBoolean write FBoolean default true;
  end;

implementation

resourcestring
   RC_FormPlace         =   'Software\BuyPin\FormPlace\';

{**************************************************}
constructor TJvFormPlace.Create(AOwner: TComponent);
begin
  inherited;
  Fboolean := true;
  FTimer := TTimer.Create(self);
  FForm := GetParentForm(TControl(AOwner));
  if not(csDesigning in ComponentState)and(FBoolean) then
  begin
    FTimer.OnTimer := Rememb;
    Ftimer.Interval := 10;
    FTimer.Enabled := true;
  end;
end;
{**************************************************}
destructor TJvFormPlace.Destroy;
var
  nam:string;
  fleft,ftop,fwidth,fheight:Integer;
begin
  if Fboolean then
    if not(csDesigning in ComponentState) then
      with TRegistry.Create do
      begin
        OpenKey(RC_FormPlace,true);
        nam:=Application.Title+'_'+FForm.Name;
        fwidth:=FForm.Width;
        fheight:=FForm.height;
        fleft:=FForm.left;
        ftop:=FForm.top;
        WriteInteger(nam+'_left',fleft);
        WriteInteger(nam+'_top',ftop);
        WriteInteger(nam+'_width',fwidth);
        WriteInteger(nam+'_height',fheight);
        Free;   
      end;
  FTimer.Free;
  inherited;
end;
{**************************************************}
procedure TJvFormPlace.Rememb(Sender: TObject);
var
   nam:string;
   fleft,ftop,fwidth,fheight:Integer;
begin
   Ftimer.enabled:=false;
   if Fboolean then
   begin
      with TRegistry.Create do
      begin
         OpenKey(RC_FormPlace,true);
         nam:=Application.Title+'_'+FForm.Name;

         if TForm(FForm).Formstyle=fsMdiChild then
         begin
            if Valueexists(nam+'_left') then fleft:=ReadInteger(nam+'_left') else fleft:=Application.MainForm.width+1;
            if Valueexists(nam+'_top') then ftop:=ReadInteger(nam+'_top') else ftop:=Application.MainForm.height+1;
            if Valueexists(nam+'_width') then fwidth:=ReadInteger(nam+'_width') else fwidth:=Application.MainForm.width+1;
            if Valueexists(nam+'_height') then fheight:=ReadInteger(nam+'_height') else fheight:=Application.MainForm.height+1;
            if (fleft>Application.MainForm.Width)or(ftop>Application.MainForm.height)or(fleft<0)or(ftop<0) then
            begin
               fwidth:=FForm.Width;
               fheight:=FForm.height;
               fleft:=(Application.MainForm.width-fwidth)div 2;
               ftop:=(Application.MainForm.height-fheight)div 2;
            end;
         end
         else
         begin
            if Valueexists(nam+'_left') then fleft:=ReadInteger(nam+'_left') else fleft:=screen.width+1;
            if Valueexists(nam+'_top') then ftop:=ReadInteger(nam+'_top') else ftop:=screen.height+1;
            if Valueexists(nam+'_width') then fwidth:=ReadInteger(nam+'_width') else fwidth:=screen.width+1;
            if Valueexists(nam+'_height') then fheight:=ReadInteger(nam+'_height') else fheight:=screen.height+1;
            if (fleft>screen.Width)or(ftop>screen.height)or(fleft<0)or(ftop<0) then
            begin
               fwidth:=FForm.Width;
               fheight:=FForm.height;
               fleft:=(screen.width-fwidth)div 2;
               ftop:=(screen.height-fheight)div 2;
            end;
         end;
         FForm.left:=fleft;
         FForm.Width:=fwidth;
         FForm.height:=fheight;
         FForm.top:=ftop;
         Free;
      end;
   end;
end;
{**************************************************}
end.
