{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvHtmlParserEditor.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvHtmlParserEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, JvFormParser;

type
  TJvHtmlParserEditor = class(TClassProperty)
  public
    function GetAttributes : TPropertyAttributes; override;
    function GetValue : string; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure SetValue(const Value: string); override;
    procedure Edit; override;
  end;

implementation

{*************************************************}
function TJvHtmlParserEditor.GetAttributes : TPropertyAttributes;
begin
   result:=[paMultiSelect, paDialog, paSortList];
end;
{*************************************************}
function TJvHtmlParserEditor.GetValue : string;
begin
   result:=GetStrValue;
end;
{*************************************************}
procedure TJvHtmlParserEditor.SetValue(const Value: string);
begin
   SetStrValue(Value);
end;
{*************************************************}
procedure TJvHtmlParserEditor.GetValues(Proc: TGetStrProc);
begin
   SetStrValue('Click to edit...');
end;
{*************************************************}
procedure TJvHtmlParserEditor.Edit;
var
   Dlg:TFormParsers;
   res:TstringList;
begin
   res:=TstringList(GetOrdValue);
   Dlg:=TFormParsers.Create(Application);
   dlg.LoadFromStr(res);
   try
    dlg.showmodal;
    if dlg.Tag=0 then
    begin
       res.assign(dlg.SetFromStr);
       SetOrdValue(integer(res));
    end;
   finally
      dlg.free;
   end;
end;
{*************************************************}
end.
