{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvLoginDlg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvLoginDlg;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvFormLogin, JvBaseDlg, JvTypes;

type
  TJvLoginDlg = class(TJvCommonDialog)
  private
    FCaption: string;
    FCaption2: string;
    FTitle: string;
    FUsername: string;
    FPassword: string;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property FirstLabel:string read FCaption write FCaption;
    property SecondLabel:string read FCaption2 write FCaption2;
    property Username:string read FUsername write FUsername;
    property Password:string read FPassword write FPassword;
    property Title:string read FTitle write FTitle;
    function Execute:boolean;override;
  end;

implementation

resourcestring
   RC_LabelPassCaption     =     'Username';
   RC_Label2Caption        =     'Password';
   RC_TitleLogin           =     'Enter login';

{**************************************************}
constructor TJvLoginDlg.Create(AOwner: TComponent);
begin
   FCaption:=RC_LabelPassCaption;
   FCaption2:=RC_Label2Caption;
   FTitle:=RC_TitleLogin;
   FUsername:='';
   FPassword:='';
   inherited;
end;
{**************************************************}
function TJvLoginDlg.Execute: boolean;
begin
   with TFormLogi.Create(Application) do
   begin
      caption:=FTitle;
      Label1.Caption:=FCaption;
      Label2.Caption:=FCaption2;
      BuEdit1.Text:=FUsername;
      BuEdit2.Text:=FPassword;
      showmodal;
      if tag=1 then
      begin
         result:=true;
         FUSername:=buEdit1.text;
         FPassword:=buEdit2.text;
      end
      else result:=false;
      free;
   end;
end;
{**************************************************}
end.
