{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvShutdownDlg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvShutdownDlg;

{$ObjExportAll On} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvBaseDlg, JvHDialogs2, JvTypes;

type
  TJvShutdownDlg = class(TJvCommonDialog)
  private
    FRestart: TJvRestart;
    FReason: string;
  protected
  public
  published
    function Execute:boolean;override;
    property Reason:string read FReason write FReason;
    property RestartType:TJvRestart read FRestart write FRestart;
  end;

implementation

{**************************************************}
function TJvShutdownDlg.Execute:boolean;
var
  flag:longint;
begin
   case FRestart of
     rsLogoff:   Flag := EWX_LOGOFF;
     rsShutdown: Flag := EWX_SHUTDOWN;
     rsReboot:   Flag := EWX_REBOOT;
     rsRestart:  Flag := EW_RESTARTWINDOWS;
     rsRebootSystem : Flag:=EW_REBOOTSYSTEM;
     rsExitAndExecApp : Flag:=EW_EXITANDEXECAPP;
     else flag:=0;
   end;
   result:=SHRestartDlg(0,pchar(FReason),flag)=IDYES;
end;
{**************************************************}
end.
