{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvSystemColors.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvSystemColors;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvTypes;

type
  TJvSystemColors = class(TComponent)
  private
    procedure SetColor(Index:Integer;Value:TColor);
    function GetColor(Index: integer):TColor;
  protected
  public
  published
    property _3DHilight:TColor index 0 read GetColor write SetColor stored false;
    property _3DLight:TColor index 1 read GetColor write SetColor stored false;
    property _3DShadow:TColor index 2 read GetColor write SetColor stored false;
    property _3DdkShadow:TColor index 3 read GetColor write SetColor stored false;
    property _3DFace:TColor index 4 read GetColor write SetColor stored false;
    property ActiveBorder:TColor index 5 read GetColor write SetColor stored false;
    property ActiveCaption:TColor index 6 read GetColor write SetColor stored false;
    property AppWorkspace:TColor index 7 read GetColor write SetColor stored false;
    property Background:TColor index 8 read GetColor write SetColor stored false;
    property BtnFace:TColor index 9 read GetColor write SetColor stored false;
    property BtnText:TColor index 10 read GetColor write SetColor stored false;
    property CaptionText:TColor index 11 read GetColor write SetColor stored false;
    property GrayText:TColor index 12 read GetColor write SetColor stored false;
    property Highlight:TColor index 13 read GetColor write SetColor stored false;
    property HighlightText:TColor index 14 read GetColor write SetColor stored false;
    property InactiveBorder:TColor index 15 read GetColor write SetColor stored false;
    property InactiveCaption:TColor index 16 read GetColor write SetColor stored false;
    property InactiveCaptionText:TColor index 17 read GetColor write SetColor stored false;
    property InfoBk:TColor index 18 read GetColor write SetColor stored false;
    property InfoText:TColor index 19 read GetColor write SetColor stored false;
    property Menu:TColor index 20 read GetColor write SetColor stored false;
    property MenuText:TColor index 21 read GetColor write SetColor stored false;
    property ScrollBar:TColor index 22 read GetColor write SetColor stored false;
    property Window:TColor index 23 read GetColor write SetColor stored false;
    property WindowFrame:TColor index 24 read GetColor write SetColor stored false;
    property WindowText:TColor index 25 read GetColor write SetColor stored false;
  end;

implementation

var
 ColorArray : array [0..25] of Integer = (COLOR_3DHILIGHT, COLOR_3DLIGHT,         //0
            COLOR_3DSHADOW, COLOR_3DDKSHADOW, COLOR_3DFACE, COLOR_ACTIVEBORDER,   //2
            COLOR_ACTIVECAPTION, COLOR_APPWORKSPACE, COLOR_BACKGROUND,            //6
            COLOR_BTNFACE, COLOR_BTNTEXT, COLOR_CAPTIONTEXT, COLOR_GRAYTEXT,      //9
            COLOR_HIGHLIGHT, COLOR_HIGHLIGHTTEXT, COLOR_INACTIVEBORDER,           //13
            COLOR_INACTIVECAPTION, COLOR_INACTIVECAPTIONTEXT, COLOR_INFOBK,       //16
            COLOR_INFOTEXT, COLOR_MENU, COLOR_MENUTEXT, COLOR_SCROLLBAR,          //19
            COLOR_WINDOW, COLOR_WINDOWFRAME, COLOR_WINDOWTEXT);                   //23

{**************************************************}
procedure TJvSystemColors.SeTColor(Index: Integer; Value: TColor);
var
  tmp:Integer;
begin
  tmp:=ColorArray[Index];
  SetSysColors(1,tmp,Value);
end;
{**************************************************}
function TJvSystemColors.GetColor(Index: integer): TColor;
begin
  result:=GetSysColor(ColorArray[Index]);
end;
{**************************************************}
end.
