{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvTransForm.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvTransForm;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  TypInfo;

type
  TJvTransForm = class(TComponent)
  private
    FActive: boolean;
    FForm: TCustomForm;
    procedure SetActive(const Value: boolean);
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property Active:boolean read FActive write SetActive default false;
  end;

implementation

{**************************************************}
constructor TJvTransForm.Create(AOwner: TComponent);
begin
  inherited;
  Factive := false;
  FForm := GetParentForm(TControl(AOwner));
  SetActive(FActive);
end;
{**************************************************}
procedure TJvTransForm.SetActive(const Value: boolean);
var
   i:Integer;
   PropInfo: PPropInfo;
   c:TComponent;
   t:Trect;
   r,s:Hrgn;
   cl:TRect;
begin
   FActive := Value;
   cl:=FForm.ClientRect;
   if FActive then
   begin
      r:=CreateRectRgn(0,0,fform.width,fform.height-cl.bottom-4);
      cl.top:=Fform.Height-cl.Bottom;
      cl.left:=fform.width-cl.Right;
      for i:=0 to FForm.ComponentCount-1 do
      begin
         c:=FForm.Components[i];
         PropInfo := GetPropInfo (C.ClassInfo,'Left');
         if PropInfo<>nil then
         begin
            t.Left:=GetOrdProp(c,PropInfo)+cl.left-4;
            PropInfo := GetPropInfo (C.ClassInfo,'Top');
            t.top:=GetOrdProp(c,PropInfo)+cl.top-4;
            PropInfo := GetPropInfo (C.ClassInfo,'Width');
            t.Right:=GetOrdProp(c,PropInfo)+t.left+2;
            PropInfo := GetPropInfo (C.ClassInfo,'Height');
            t.Bottom:=GetOrdProp(c,PropInfo)+t.top+2;
            s:=CreateRectRgn(t.left,t.top,t.right,t.bottom);
            CombineRgn(r,r,s,RGN_OR);
         end;
      end;
   end
   else
        r:=0;

   SetWindowRgn(FForm.handle,r,true);
end;
{**************************************************}
end.
